

//var http = require("http");
//var nconf = require('nconf');
//nconf.file('./node_modules/alh_spider/config.json');
var redis = require('redis');

var async = require("async");
var client;
var dbhead="";

//////////////////////////////////////////////////////
var fs = require("fs");
var jquery = fs.readFileSync("./node_modules/alh_spider/jquery.js", "utf-8");


//////////////////////////////////////////////////////

exports.run = run;
//exports.main = main;

//process.exit();
//hset url_seed_list http://www.expressjs.com.cn ""

function writedb(url,parenturl,st,callback)
{
	//console.log("writedb");
	if (st=="pass") {
		client.hset(dbhead+"url_list",url,parenturl,function(err,rt){
			if (err) {
				console.log("hset:"+err);
			}
			console.log("Pass URL:"+url);
			callback();
		});
	}
	if (st=="seed") {
		client.hexists(dbhead+"url_list",url,function(err1,rt1){
			if (rt1==0) {
				client.hexists(dbhead+"url_error",url,function(err2,rt2){
					if (rt2==0) {
						var obj={};
						obj.url=url;
						obj.parenturl=parenturl;
						var jsondata=JSON.stringify(obj);
						client.lpush(dbhead+"url_seed",jsondata,function(){
							callback();
						});
					}
					else{
						callback();
					}
				});
			}
			else{
				callback();
			}
		});
	}
	if (st=="error") {
		client.hset(dbhead+"url_error",url,parenturl,function(){
			callback();
		});
	}
}

function gethtml(url,parenturl,callback)
{
	//try{
	console.log("-----------------------------------------------------------");
	console.log("GETHTML:"+url);
	var regx=/https:\/\//;
	var rt=regx.test(url);
	if (rt) {
		var http = require("https");
	}
	else
	{
		var http = require("http");
	}

	var jsdom = require("jsdom");
	var data=[];
	var options=require('url').parse(url);

	var options1 = {
		hostname: options.hostname,
		port: 80,
		path: options.path,
		method: 'GET',
		headers:{
			'Accept':'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
			'Accept-Encoding':'gzip, deflate, sdch',
			'Accept-Language':'zh-CN,zh;q=0.8',
			'Cache-Control':'no-cache',
			'Connection':'keep-alive',
			'Pragma':'no-cache',
			'Upgrade-Insecure-Requests':'1',
			'User-Agent':'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.125 Safari/537.36'
		}
	}

	var pagesize=0;
	var req = http.get(options1,function(res) {

			var ontime = setTimeout(function() {
				console.log('on time');
				req.abort();
				callback("error");
			},60000);

			var timeout=true;
			res.on('data',function(chunk) {
				timeout=false;
				data.push(chunk);
				pagesize+=chunk.length;
				if (pagesize>10000000) {
					console.log('too big');
					req.abort();
					clearTimeout(ontime);
					callback("error");
				}
			});

			res.on('end',function() {
				timeout=false;
				var zlib = require('zlib');
				// 非gzip/deflate要转成utf-8格式
				var encoding = res.headers['content-encoding'];

		  		// if( encoding === 'undefined'){
				//       res.setEncoding('utf-8');
				// }
		        var buffer = Buffer.concat(data);
		        var rtstr="";
		        var html="";
		        async.series([
					function (callback1){
				        if (encoding == 'gzip') {
		                	zlib.gunzip(buffer, function (err, decoded) {
		                    	html = decoded.toString();
		                    	callback1(null, '1');
			                });
			            }
			            else if (encoding == 'deflate') {
			                zlib.inflate(buffer, function (err, decoded) {
			                    html = decoded.toString();
			                    callback1(null, '1');
			                });
			            }
			            else {
			                html = buffer.toString();
			                callback1(null, '1');
			            }
			        },
			        function (callback1){
			        	//console.log(html);
				//req.abort();
				//////////////////////////////////////////////////////////////////////////
			    jsdom.env({//url: url,
			    	html: html,
			    	src: [jquery],
			    	done: function (errors, window) {
						if (errors) {
							console.log("jsdom error:"+errors);
							if (window!=null && window!=undefined) {
								window.close();
							}
							clearTimeout(ontime);
							callback("error");
							//rtstr="error";
							//callback1(null, '2');
						}
						else{
							if (window==undefined || window==null) {
								clearTimeout(ontime);
								callback("error");
								//rtstr="error";
								//callback1(null, '2');
							}
							else{
								var i=0;
								console.log("HREF COUNT:"+window.$("a").length);
								async.whilst(
									function(){
										return i<window.$("a").length;
									},
									function(next){
										var href=window.$("a:eq("+i+")").attr("href");
										checkurl(href,url,function(isurl,geturl){
											if (isurl==true) {
												writedb(geturl,url,"seed",function(){
												 	i++;
												 	next();
												});
											}
											else{
												//console.log("无效网址:"+href);
												i++;
											 	next();
											}
										});

									},
									function(err,n){
										if (window!=null && window!=undefined) {
											window.close();
										}
										clearTimeout(ontime);
										callback("pass");
										//rtstr="pass";
										//callback1(null, '2');
									}
								);
							}
						}
					}
				});
				//////////////////////////////////////////////////////////////////////////
				}],
				function (err, results){
					//callback(rtstr);
				});
			});//res.on


			// console.log('too big');
			// req.abort();
			// callback("error");

	});//http.get

	req.setTimeout(60000,function() {
	 	console.log('time out');
	 	req.abort();
 		callback("error");
	});
	req.on('error',function(err) {
		req.abort();
		console.log('request error: ' + err.message);
		callback("error");
	});


	//}
	// catch(e)
	// {
	// 	console.log('jsdom.env error:'+e);
	// 	callback("error");
	// }
	// process.on('uncaughtException', function (err) {
 	// console.log(err);
 	// callback("error");
	// });
}

function checkurl(url,parenturl,callback)
{
	if (url!=null && url!="") {
		var tempurl=url.toLowerCase();
		var regx1=/http:\/\//;
		var regx2=/https:\/\//;
		var rt1=regx1.test(tempurl);
		var rt2=regx2.test(tempurl);
		if (rt1 || rt2) {
			callback(true,url);
		}
		else if (url.trim()=="#" || url.trim()=="/" || url.trim()=="/#") {
			//console.log(url);
			callback(false,"");
		}
		else if(tempurl.indexOf("javascript:")!=-1){
			callback(false,"");
		}
		else if (rt1==false && rt2==false) {
			if (parenturl==""||parenturl==null) {
				callback(true,'http://'+url);
			}
			var purl=parenturl.replace(/\\/g,'/');
			var urlhead=purl.match(/(http|https):\/\/[^\/]+/);
			if (url[0]=='/' || url[0]=='\\') {
				callback(true,urlhead[0]+url);
			}
			else{
				callback(true,urlhead[0]+'/'+url);
			}
		}
	}
	else
	{
		callback(false,"");
	}
}


function main()
{
	var n=0;
	async.whilst(
		function(){
			return true;
		},
		function(callback){
			client.rpop(dbhead+"url_seed",function(err,rt){
				if (rt!=null) {
					var obj=JSON.parse(rt);
					var url=obj.url;
					var parenturl=obj.parenturl;

					//console.log("GETHTML:"+url);
					n++;
					client.hexists(dbhead+"url_list",url,function(err1,rt1){
						if (rt1==0) {
							client.hexists(dbhead+"url_error",url,function(err2,rt2){
								if (rt2==0) {
									gethtml(url,parenturl,function(result){
										writedb(url,parenturl,result,function(){
											callback(null,n);
										});
									});

								}
								else{
									callback(null,n);
								}
							});
						}
						else{
							callback(null,n);
						}
					});
				}
				else{
					callback("null",0);
				}
			});
		},
		function(err,n){
			process.exit();
		}
	);
}

function run(redis_ip,port,dbmark,dbn,url)
{
	dbhead = dbmark;
	client = redis.createClient(port,redis_ip,{});
	var obj={};
	client.select(dbn,function(){
		if (url!=null && url!=undefined) {
			obj.url=url;
			obj.parenturl=url;
			var inistr=JSON.stringify(obj);
			client.rpush(dbhead+"url_seed",inistr,function(){
				main();
			});
		}
		else{
			main();
		}
	});
	process.on('uncaughtException', function (err) {
    	console.log("uncaughtException:"+err);
    	main();
	});
}